from SimpleHTTPServer import SimpleHTTPRequestHandler
from SocketServer import ThreadingMixIn
from BaseHTTPServer import HTTPServer
import json
import sys
import base64
from tencentcloud.common import credential
from tencentcloud.common.exception.tencent_cloud_sdk_exception import TencentCloudSDKException
from tencentcloud.drm.v20181115 import drm_client, models


hostIP = '127.0.0.1'
portNum = 8293

secretid = "AKIDeBWhfRZDCzWnoYfHFwNXR4RYP1NUIyOc"
secretkey = "95nIZcS4TebKp6A0d2EBuQimcFepmX4N"
endpoint = "drm.tencentcloudapi.com"

def TransUserReq(datas):
    d_l = datas.split("&")
    spc = ""
    for i in d_l:
        if i.startswith("spc="):
            spc = i
            spc = spc.replace("spc=","")
    d_req = {"DrmType":"fairplay",
    "LicenseRequest":spc,
    "ContentType":"LiveVideo"}
    j_req = json.dumps(d_req)
    return j_req

       
class myProxyServer( SimpleHTTPRequestHandler ):
    def SendToClient(self,code,rsp):
        self.send_response(code)
        self.send_header("Content-type","text/html;charset=utf-8")
        self.send_header("Content-Length",len(rsp))
        self.send_header("Access-Control-Allow-Origin","*")
        self.end_headers()
        self.wfile.write(rsp)
    def do_POST(self):
        try:
            # get origin datas
            content_len = self.headers['content-length']
            datas = self.rfile.read(int(content_len))
            # trans user origin request
            j_req = TransUserReq(datas)
            # use tencent cloud api
            cred = credential.Credential(secretid, secretkey)
            client = drm_client.DrmClient(cred, "ap-shanghai")
            # create request
            req = models.CreateLicenseRequest()
            req.from_json_string(j_req)
            # get response
            resp = client.CreateLicense(req)
            rsp = json.loads(resp.to_json_string())
            license =  rsp["License"]
            license = "\n<ckc>%s</ckc>\n"%license
            self.SendToClient(200,license)

        except TencentCloudSDKException as err:
            self.SendToClient(200,repr(err))
  
 
class ThreadingHttpServer( ThreadingMixIn, HTTPServer ):
    pass
     
myServer = ThreadingHttpServer( (hostIP,portNum), myProxyServer )
myServer.serve_forever()
